fl

\ Read 3bytes
\ ( -- )
: 3_eeread 0 _eeread 0 _eeread 0 _eeread ;

\ Read FIFO data
\ ( n1 -- ) n1:Gesture FIFO level 
: rdFIFOBlk
\ Start I2C 
_eestart
\ Write slave address[wr], then receive Acknowledge-bit(ACK:Lo  NACK:Hi)   
APDS-9960 _eewrite                 \ ( n1 t/f )  
\ Write register
APDS9960_GFIFO_U _eewrite or       \ ( n1 t/f )  
\ Start read_process
Sr
\ Write slave address[rd], then receive Acknowledge-bit(ACK:Lo  NACK:Hi)
APDS-9960 1 or _eewrite or swap    \ ( t/f n1 )
\ Read (n1x4)bytes
                                                    ." GFLVL"  st?
0 do
     lasti?
     if
               3_eeread -1 _eeread
     else
               3_eeread 0 _eeread 
     then
     \ Save to FIFO-buffer                                               
     >r >r 8 lshift or r> d16 lshift or r> d24 lshift or
     FIFO i 4* + gestureDataTotal W@ 4* + L!
loop                                                       
\ Stop I2C
_eestop                            \ ( t/f )      
err?                               \ ( -- )         
;

\ Reset Gesture Parameter
\ ( -- )
: rstGestureParam
\ 0 gestureDataIndex W!
0 gestureDataTotal W!
\ 0 gesture_ud_delta L!
\ 0 gesture_lr_delta L!
0 gesture_ud_count L!
0 gesture_lr_count L!
\ 0 gesture_near_count L!
\ 0 gesture_far_count L!
;

\ Enable GestureSensor
\ ( -- )
: enableGestureSensor
rstGestureParam                                        \ Reset Gesture parameter
enablePower                                            \ Power on
hFF APDS9960_WTIME APDS_i2c_wr                         \ Set WTIME
LED_BOOST_300 4 lshift APDS9960_CONFIG2 APDS_i2c_wr    \ Set additional LDR current
APDS9960_PEN 1 APDS9960_ENABLE bitControl              \ Enable PEN to enter into gesture engine
APDS9960_WEN  1 APDS9960_ENABLE bitControl             \ Enable WEN to enter into gesture engine
APDS9960_GEN 1 APDS9960_ENABLE bitControl              \ Enable GEN to enter into gesture engine
1 setGIEN                                              \ Set GIEN to active
APDS9960_GMODE 1 APDS9960_GCONF4 bitControl            \ SET Gesture Mode
;

\ 
\ ( -- )
: Gesture_test
\ Initialize
clr_matrix
c" matrix _matrix_Charlie_asm" 0 cogx
6 delms
init_APDS-9660
enableGestureSensor
                       h40 APDS9960_GCONF1 APDS_i2c_wr
                           
begin
                                            ." under waiting GINT" cr
     begin
          \ Check Gesture Interrupt bit[h93:bit2]
          APDS9960_STATUS APDS_i2c_rd 4 and
                                                                    
     until
                                                  cr cr cr
     \ Keep looping as long as gesture data is valid
     begin
                                                            
          d30 delms                                          
          \ Check if FIFO data is valid  (GVALID[hAF:bit0])
          APDS9960_GSTATUS APDS_i2c_rd APDS9960_GVALID and
          if
               \ Get Gesture FIFO level Register[hAE]
               APDS9960_GFLVL APDS_i2c_rd dup 
                                                           st? gestureDataTotal W@ . cr
               rdFIFOBlk                     \ Save dataset block from FIFO to FIFO buffer
               dup
               gestureDataTotal W@ + d256 <
               if  
                    gestureDataTotal W+!
               else
                    drop
                    
               then 
               0     
\ --- Debug ---------------------------------------------------------------------------------------
[ifdef debug
\ dispReg
\ FIFO d128 dump
\ Print Up/Down/Left/Right
prtUDLR
." Gestute FIFO Data Total:" gestureDataTotal W@ . cr
]                                          
\ -------------------------------------------------------------------------------------------------   
            
          else
               procGesture
               decdodeGesture
               dup
               1- matrixArrow
               
               1 over =            \ case UP
               if ." UP"
               else 2 over =       \ case DOWN
               if ." DOWN"
               else 3 over =       \ case RIGHT
               if ." RIGHT"
               else 4 over =       \ case LEFT
               if ." LEFT"
               else ." Can't judge direction"
               then then then then
               drop 
               d1000 delms
               clr_matrix 
               cr
               rstGestureParam           
               1
          then
     until     
     \ Clear GINT
     4 1 APDS9960_GCONF4 bitControl 
     fkey? swap drop
until
;
























{
\ Print Up/Down/Left/Right
\ ( -- )
: prtFIFO
." U" tab ." D" tab ." L" tab ." R" cr
FIFO
fifo_lvl W@ 0 do
     dup i 4* + dup           \ ( FIFOaddr FIFOaddr+[4xi] FIFOaddr+[4xi] ) 
     4 bounds do              \ ( FIFOaddr FIFOaddr+[4xi] )
          dup C@ . 1+ tab     \ ( FIFOaddr FIFOaddr+[4xi]+1 )
     loop                     
     drop cr                  \ ( FIFOaddr )
loop
drop     
; 


\ Read FIFO data
\ ( n1 -- ) n1:Gesture FIFO level 
: rdFIFO
\ Start I2C 
_eestart
\ Write slave address[wr], then receive Acknowledge-bit(ACK:Lo  NACK:Hi)   
APDS-9960 _eewrite                 \ ( n1 t/f )  
\ Write register
APDS9960_GFIFO_U _eewrite or       \ ( n1 t/f )  
\ Start read_process
Sr
\ Write slave address[rd], then receive Acknowledge-bit(ACK:Lo  NACK:Hi)
APDS-9960 1 or _eewrite or swap    \ ( t/f n1 )
\ Read (n1x4)bytes
                                                    ." GFLVL"  st?
0 do
     lasti?
     if
               3_eeread -1 _eeread
     else
               3_eeread 0 _eeread 
     then
                                                    \   st?
     \ Save to FIFO-buffer                                               
     >r >r 8 lshift or r> d16 lshift or r> d24 lshift or 
     FIFO i 4* + L!
loop
\ Stop I2C
_eestop                            \ ( t/f )      
err?                               \ ( -- )         
;

variable count 
\ Test gesture
\ ( -- )
: dispFIFO
\ Initialize
6 delms
init_APDS-9660
enableGestureSensor
                       h80 APDS9960_GCONF1 APDS_i2c_wr
                            0 count L!
begin
                                            ." under waiting GINT" cr
     begin
          \ Check Gesture Interrupt bit[h93:bit2]
          APDS9960_STATUS APDS_i2c_rd 4 and
                                                                    
     until
                                                  cr cr cr
     \ Keep looping as long as gesture data is valid
     begin
                                                               ." ---count---:"    count L@ . cr
          d30 delms                                          
          \ Check if FIFO data is valid  (GVALID[hAF:bit0])
          APDS9960_GSTATUS APDS_i2c_rd APDS9960_GVALID and
          if
               \ Check Gesture FIFO level Register[hAE]
               APDS9960_GFLVL APDS_i2c_rd dup
               fifo_lvl W!
               rdFIFO              \ Save dataset block from FIFO to FIDO buffer                            
               0
                                   count L@ 1+ count L!
\ --- Debug ---------------------------------------------------------------------------------------
[ifdef debug
\ dispReg
\ FIFO d128 dump
\ Print Up/Down/Left/Right
prtFIFO
." Gestute FIFO Level:" fifo_lvl W@ . cr
]                                          
\ -------------------------------------------------------------------------------------------------               
          else
               1
          then
     until
     \ Clear GINT
     4 1 APDS9960_GCONF4 bitControl 
                                        
     fkey? swap drop
until
;
}
